<template>
  <div>
    <button @click="handleLogOut()" class="x x-fixed-2">log-out</button>
    <base-card>
      <button
        @click="setSelectedTab('stored-resources')"
        :class="{ flat: selectedTab === 'add-resource' }"
      >
        Stored Resources
      </button>
      <button
        @click="setSelectedTab('add-resource')"
        :class="{ flat: selectedTab === 'stored-resources' }"
      >
        Add Resource
      </button>
    </base-card>
    <keep-alive>
      <component :is="selectedTab" :resources="storedResources"></component>
    </keep-alive>
  </div>
</template>

<script>
import StoredResources from "./StoredResources.vue";
import AddResource from "./AddResource.vue";
import axios from "axios";
import * as Keycloak from "keycloak-js";
// axios.defaults.baseURL = "http://myurl";
// axios.defaults.headers.post["Content-Type"] = "application/json;charset=utf-8";
// axios.defaults.headers.post["Access-Control-Allow-Origin"] = "*";
export default {
  mounted() {
    this.login();
  },
  components: {
    StoredResources,
    AddResource,
  },
  created() {
    // console.log(
    //   this.$axios.get("http://localhost:5000/test", config).then((res) => {
    //     console.log(res.data);
    //     console.log(res.status);
    //     console.log(res.statusText);
    //     console.log(res.headers);
    //     console.log(res.config);
    //   })
    // );
    axios.get("https://fantastic-api.mac.pl:5000/allResources").then((res) => {
      console.log(typeof res.data, res.data);
      this.storedResources = res.data.reverse();
    });
  },
  data() {
    return {
      test: "test",
      selectedTab: "stored-resources",
      storedResources: null,
      // storedResources: [
      //   {
      //     id: "official-guide",
      //     title: "Official Guide",
      //     description: "The official Vue.js documentation.",
      //     link: "https://vuejs.org",
      //   },
      //   {
      // id: "google",
      // title: "Google",
      // description: "Learn to google...",
      // link: "https://google.org",
      //   },
      // ],
    };
  },
  provide() {
    return {
      // resources: this.storedResources,   //provide jest niereaktywny!!! czyli w tym momencie ma null
      addResource: this.addResource,
      removeResource: this.removeResource,
      editResource: this.editResource,
    };
  },

  methods: {
    setSelectedTab(tab) {
      this.selectedTab = tab;
    },
    addResource(title, description, link) {
      const newResource = {
        id: new Date().toISOString(),
        title: title,
        description: description,
        link: link,
      };
      console.log(newResource);
      axios
        .post("https://fantastic-api.mac.pl:5000/resource", newResource)
        .then((res) => {
          console.log(res);
        })
        .catch((err) => {
          console.log("error in axios post: ", err);
        });
      this.storedResources.unshift(newResource);
      this.selectedTab = "stored-resources";
    },
    removeResource(resId) {
      const resIndex = this.storedResources.findIndex((el) => el.id === resId);
      this.storedResources.splice(resIndex, 1);
      console.log(resId);
      axios
        .delete(`https://fantastic-api.mac.pl:5000/resource/${resId}`)
        .then((res) => {
          console.log(res);
        })
        .catch((err) => {
          console.log("error in axios delete: ", err);
        });
    },
    editResource(resId, title, description, link) {
      // console.log("arguments editREsource resId: ", resId);
      // console.log("arguments editREsource title: ", title);
      // console.log("arguments editREsource description: ", description);
      // console.log("arguments editREsource: link", link);
      const updatedResource = {
        title: title,
        description: description,
        link: link,
      };
      const resIndex = this.storedResources.findIndex((el) => el.id === resId);
      this.storedResources[resIndex].title = title;
      this.storedResources[resIndex].description = description;
      this.storedResources[resIndex].link = link;
      console.log(resIndex);
      axios
        .patch(
          `https://fantastic-api.mac.pl:5000/resource/${resId}`,
          updatedResource
        )
        .then((res) => {
          console.log(res);
        })
        .catch((err) => {
          console.log("error in axios patch: ", err);
        });
    },

    // KEYCLOAK FN

    handleLogOut() {
      const MY_REALM = "test";
      const ENCODED_REDIRECT_URI = `${process.env.VUE_APP_BASE_APP_URL}`;
      window.location.replace(
        `${process.env.VUE_APP_BASE_KEYCLOAK_URL}realms/${MY_REALM}/protocol/openid-connect/logout?redirect_uri=${ENCODED_REDIRECT_URI}`
      );
    },
    login() {
      var keycloak = Keycloak({
        realm: `test`,
        url: `${process.env.VUE_APP_BASE_KEYCLOAK_URL}`,
        clientId: `fantastic-app`,
        "ssl-required": "all",
        resource: `fantastic-app`,
        "public-client": true,
        "confidential-port": 0,
      });
      keycloak
        .init({
          // flow: 'implicit',
          promiseType: "native",
          onLoad: "login-required",
        })
        .then((authenticated) => {
          this.$store.commit("TOKEN_SET", authenticated);
          console.log("TOKEN", authenticated);
          return authenticated;
        })
        .catch((error) => {
          console.error(error);
        });
      keycloak.onTokenExpired = () => {
        keycloak
          .updateToken(30)
          .then((refreshed) => {
            if (refreshed) {
              this.$store.commit("TOKEN_SET", keycloak.token);
            } else {
              console.log("Token is still valid");
            }
          })
          .catch((error) => {
            console.error(error);
          });
      };
    },
  },
};
</script>

<style scoped>
div {
  text-align: left;
}
button {
  padding: 0.75rem 1.5rem;
  font-family: inherit;
  background-color: #3a0061;
  border: 1px solid #3a0061;
  color: white;
  cursor: pointer;
  transition: 0.2s;
}

button:hover,
button:active {
  background-color: #270041;
  border-color: #270041;
}

.flat {
  background-color: transparent;
  color: #3a0061;
  border: none;
}

.flat:hover,
.flat:active {
  background-color: #edd2ff;
}

.x {
  margin: 8px;
  padding: 8px;
  cursor: pointer;
  font-weight: bold;
  transition: 0.3s;
  background-color: #edd2ff;
  border: 1px solid #000;
  color: black;
}
.x:hover {
  color: white;
  background-color: #3a0061;
}
.x-fixed-2 {
  position: absolute;
  top: 10px;
  right: 10px;
}
</style>
